* Program............: C:\DB4\CALEND.FRG
* Date...............: 5-20-89
* Versions...........: dBASE IV, Report 1
*
* Notes:
* ------
* Prior to running this procedure with the DO command
* it is necessary use LOCATE because the CONTINUE
* statement is in the main loop.
*
*-- Parameters
PARAMETERS gl_noeject, gl_plain, gl_summary, gc_heading, gc_extra
** The first three parameters are of type Logical.
** The fourth parameter is a string.  The fifth is extra.
PRIVATE _peject, _wrap

*-- Test for no records found
IF EOF() .OR. .NOT. FOUND()
   RETURN
ENDIF

*-- turn word wrap mode off
_wrap=.F.

IF _plength < 7
   SET DEVICE TO SCREEN
   DEFINE WINDOW gw_report FROM 7,17 TO 11,62 DOUBLE
   ACTIVATE WINDOW gw_report
   @ 0,1 SAY "Increase the page length for this report."
   @ 2,1 SAY "Press any key ..."
   x=INKEY(0)
   DEACTIVATE WINDOW gw_report
   RELEASE WINDOW gw_report
   RETURN
ENDIF

_plineno=0          && set lines to zero
*-- NOEJECT parameter
IF gl_noeject
   IF _peject="BEFORE"
      _peject="NONE"
   ENDIF
   IF _peject="BOTH"
      _peject="AFTER"
   ENDIF
ENDIF

*-- Set-up environment
ON ESCAPE DO prnabort
IF SET("TALK")="ON"
   SET TALK OFF
   gc_talk="ON"
ELSE
   gc_talk="OFF"
ENDIF
gc_space=SET("SPACE")
SET SPACE OFF
gc_time=TIME()      && system time for predefined field
gd_date=DATE()      && system date  "    "    "     "
gl_fandl=.F.        && first and last page flag
gl_prntflg=.T.      && Continue printing flag
gl_widow=.T.        && flag for checking widow bands
gn_length=LEN(gc_heading)  && store length of the HEADING
gn_level=2          && current band being processed
gn_page=_pageno     && grab current page number



*-- Set up procedure for page break
IF _pspacing > 1
   gn_atline=_plength - (_pspacing + 1)
ELSE
   gn_atline=_plength - 2
ENDIF
ON PAGE AT LINE gn_atline EJECT PAGE

*-- Print Report

PRINTJOB

*-- Initialize group break vars.
r_mvar4=settimana+giorno
r_mvar5=CODICE

*-- Initialize summary variables.
r_msum1=0
r_msum2=0
r_msum3=0

IF gl_plain
   ON PAGE AT LINE gn_atline DO Pgplain
ELSE
   ON PAGE AT LINE gn_atline DO Pgfoot
ENDIF

DO Pghead

gl_fandl=.T.        && first physical page started

DO Rintro

DO Grphead

*-- File Loop
DO WHILE FOUND() .AND. .NOT. EOF() .AND. gl_prntflg
   DO CASE
   CASE .NOT. (settimana+giorno = r_mvar4)
      gn_level=4
   CASE .NOT. (CODICE = r_mvar5)
      gn_level=5
   OTHERWISE
      gn_level=0
   ENDCASE
   *-- test whether an expression didn't match
   IF gn_level <> 0
      DO Grpfoot WITH 100-gn_level
      DO Grpinit
   ENDIF
   *-- Repeat group intros
   IF gn_level <> 0
      DO Grphead
   ENDIF
   DO Upd_Vars
   *-- Detail lines
   IF .NOT. gl_summary
      DO Detail
   ENDIF
   CONTINUE
ENDDO

IF gl_prntflg
   gn_level=3
   DO Grpfoot WITH 97
   DO Rsumm
   IF _plineno <= gn_atline
      EJECT PAGE
   ENDIF
ELSE
   gn_level=3
   DO Rsumm
   DO Reset
   RETURN
ENDIF

ON PAGE

ENDPRINTJOB

DO Reset
RETURN
* EOP: C:\DB4\CALEND.FRG

*-- Update summary fields and/or calculated fields in the detail band.
PROCEDURE Upd_Vars
*-- Summary calculation - Sum
r_msum1=r_msum1+DURATA
*-- Summary calculation - Sum
r_msum2=r_msum2+DURATA
*-- Summary calculation - Sum
r_msum3=r_msum3+DURATA
RETURN
* EOP: Upd_Vars

*-- Set flag to get out of DO WHILE loop when escape is pressed.
PROCEDURE prnabort
gl_prntflg=.F.
RETURN
* EOP: prnabort

*-- Reset group break variables.  Reinit summary
*-- fields with reset set to a particular group band.
PROCEDURE Grpinit
IF gn_level <= 5
   r_msum1=0
ENDIF
IF gn_level <= 4
   r_msum2=0
ENDIF
IF gn_level <= 4
   r_mvar4=settimana+giorno
ENDIF
IF gn_level <= 5
   r_mvar5=CODICE
ENDIF
RETURN
* EOP: Grpinit

*-- Process Group Intro bands during group breaks
PROCEDURE Grphead
IF EOF()
   RETURN
ENDIF
gl_widow=.T.         && enable widow checking
IF gn_level <= 4
   DO Head4
ENDIF
IF gn_level <= 5
   DO Head5
ENDIF
gn_level=0
RETURN
* EOP: Grphead.PRG

*-- Process Group Summary bands during group breaks
PROCEDURE Grpfoot
PARAMETER ln_level
IF ln_level >= 95
   DO Foot95
ENDIF
IF ln_level >= 96
   DO Foot96
ENDIF
RETURN
* EOP: Grpfoot.PRG

PROCEDURE Pghead
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
?? "Polo: " AT 0,
?? POLO FUNCTION "T" 
?
?
?
?
*-- Print HEADING parameter ie. REPORT FORM <name> HEADING <expC>
IF .NOT. gl_plain .AND. gn_length > 0
   ?? gc_heading FUNCTION "I;V"+LTRIM(STR(_rmargin-_lmargin))
   ?
ENDIF
RETURN
* EOP: Pghead

PROCEDURE Rintro
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
?? "Settimana: " AT 0,
?? SETTIMANA FUNCTION "T" 
?
?
RETURN
* EOP: Rintro

PROCEDURE Head4
IF gn_level=1
   RETURN
ENDIF
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
IF 2 < _plength
   IF (gl_widow .AND. _plineno+6 > gn_atline) ;
   .OR. (gl_widow .AND. _plineno+1 > gn_atline)
      EJECT PAGE
   ENDIF
ENDIF
?? "Giorno: " AT 0,
?? GIORNO FUNCTION "T" ,
?? "  " 
?
?
RETURN

PROCEDURE Head5
IF gn_level=1
   RETURN
ENDIF
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
IF 4 < _plength
   IF (gl_widow .AND. _plineno+4 > gn_atline) ;
   .OR. (gl_widow .AND. _plineno+3 > gn_atline)
      EJECT PAGE
   ENDIF
ENDIF
?
?? NOME FUNCTION "T" AT 0,
?? "Cod: " AT 64,
?? CODICE FUNCTION "T" 
?
?
?? "  Ar Iniz   min Tema Tipo" AT 0
?
RETURN

PROCEDURE Detail
PRIVATE _indent, _lmargin, _rmargin, _tabs
IF .NOT. _wrap
   PRIVATE _wrap
   _wrap = .T.
ENDIF
_indent=0
_lmargin=0
_pcolno=0
_rmargin=254
_tabs=;
"8,16,24,32,40,48,56,64,72,80,88,96,104,112,120,128,136,144,152,160,168";
+ ",176,184,192,200,208,216,224,232,240";

?? "  " ,
?? AREA FUNCTION "T" ,
?? "  " ,
?? ORAINIZ PICTURE "99.99" ,
?? "  " ,
?? DURATA PICTURE "999" ,
?? "  " ,
?? TEMA FUNCTION "T" ,
?? "  " ,
?? TIPLEZ FUNCTION "T" ,
?? "  " ,
?? DESCR FUNCTION "T" 
?
RETURN
* EOP: Detail

PROCEDURE Foot95
PRIVATE _indent, _lmargin, _rmargin, _tabs
IF .NOT. _wrap
   PRIVATE _wrap
   _wrap = .T.
ENDIF
_indent=0
_lmargin=0
_pcolno=0
_rmargin=254
_tabs=;
"8,16,24,32,40,48,56,64,72,80,88,96,104,112,120,128,136,144,152,160,168";
+ ",176,184,192,200,208,216,224,232,240";

?
_indent=0
_lmargin=0
_pcolno=0
_rmargin=254
_tabs=;
"8,16,24,32,40,48,56,64,72,80,88,96,104,112,120,128,136,144,152,160,168";
+ ",176,184,192,200,208,216,224,232,240";

?? "Unita':    " ,
?? r_msum1 FUNCTION "T" PICTURE "9999999.99" ,
?? "  min      " 
?
RETURN

PROCEDURE Foot96
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
?
?
?? "--------------------------" AT 0
?
?? "Giorno:" AT 0,
?? r_msum2 PICTURE "9999999.99" AT 11,
?? "min" AT 23
?
RETURN

PROCEDURE Rsumm
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
?
?? "Settimana:" AT 0,
?? r_msum3 PICTURE "9999999.99" AT 11,
?? "min" AT 23
?
?
?? ;
"======================================================================";
+ "==========";
AT 0
gl_fandl=.F.        && last page finished
?
RETURN
* EOP: Rsumm

PROCEDURE Pgfoot
PRIVATE _box
gl_widow=.F.         && disable widow checking
?
IF .NOT. gl_plain
IF _wrap
   PRIVATE _wrap
   _wrap = .F.
ENDIF
ENDIF
EJECT PAGE
*-- is the page number greater than the ending page
IF _pageno > _pepage
   GOTO BOTTOM
   SKIP
   gn_level=0
ENDIF
IF .NOT. gl_plain .AND. gl_fandl
   DO Pghead
ENDIF
IF gn_level = 0 .AND. gl_fandl
   gn_level=1
   DO Grphead
ENDIF
gl_widow=.T.         && enable widow checking
RETURN
* EOP: Pgfoot

*-- Process page break when PLAIN option is used.
PROCEDURE Pgplain
PRIVATE _box
EJECT PAGE
IF gn_level = 0 .AND. gl_fandl
   gn_level=1
   DO Grphead
ENDIF
RETURN
* EOP: Pgplain

*-- Reset dBASE environment prior to calling report
PROCEDURE Reset
SET SPACE &gc_space.
SET TALK &gc_talk.
ON ESCAPE
ON PAGE
RETURN
* EOP: Reset

