Unit Op_Compl ;
Interface
Type
  ElComplesso = Record
                 pr,
                 pi,
                 mo,
                 ar  : Real
                End ;
  Complesso  = ^ElComplesso ;
Function ParteReale ( z : complesso ) : real ;
Function ParteImmaginaria ( z : complesso ) : real ;
Function Modulo ( z : complesso ) : real ;
Function Argomento ( z : complesso ) : real ;
Function FaiRettangolare ( a,b : real ) : complesso ;
Function FaiPolare ( ro,teta : real ) : complesso ;
{ < altre operazioni > }
Implementation
Function ParteReale ( z : complesso ) : real ;
begin
  ParteReale := z^.pr ;
end  ; { ParteReale }
Function ParteImmaginaria ( z : complesso ) : real ;
begin
  ParteImmaginaria := z^.pi ;
end  ; { ParteImmaginaria }
Function Modulo ( z : complesso ) : real ;
begin
  Modulo := z^.mo ;
end ;  { Modulo }
Function Argomento ( z : complesso ) : real ;
begin
  Argomento := z^.ar ;
end ; { Argomento }
Function FaiRettangolare ( a,b : real ) : complesso ;
Var
  compl : complesso ;
begin
  New (compl) ;
  With compl^ do
    begin
      pr := a ;
      pi := b ;
      mo := Sqrt ( sqr(a) + sqr(b) ) ;
      ar := Arctan ( b/a) ;
    end ; { with }
end ; { FaiRettangolare }
Function FaiPolare ( ro,teta : real ) : complesso ;
Var compl : complesso ;
begin
  New ( compl ) ;
  With compl^ do
    begin
      mo := ro ;
      ar := teta ;
      pr := ro* Cos(teta) ;
      pi := ro* Sin(teta) ;
    end ; { With }
end ;  { FaiPolare }
end.
